<?
function page_exists($name,$filename,$pub_dir,$node_id,$folder_id,$id = 0) {

global $ERROR, $DIC;

//                         
 $pub_dir = sqlslashes($pub_dir);
$filename = sqlslashes($filename);  

//                   
 $cs_id = 0;
if ($id) {
$info = get_pageinfo($id);
$cs_id = $info["contentset_id"];
}

$sql = "SELECT id FROM folder WHERE pub_dir = '".sqlf_escaped($pub_dir)."' AND node_id = ".sqlf_tl_num($node_id);
$rs = query($sql);//            
 $keys = "-1";
if ($rs["arr"])
while (list($key,$row) = each($rs["arr"])) {
$keys .= ",".sqlf_tl_num($row["id"]);
}
$sql = "SELECT name, folder_id FROM page"
. " WHERE page.filename = '".sqlf_escaped($filename)."' AND page.folder_id IN ($keys) AND page.id != ".sqlf_tl_num($id);
$rs2 = query($sql);//            
 if ($rs2["num"]) {
$folderinfo = get_folderinfo($rs2["arr"][0]["folder_id"], true);
$fullpath   = $folderinfo["fullpath"]["name"] . '/' . $rs2["arr"][0]["name"];
$ERROR["filename"] = i18n("A page with this filename already exists:<br/> {0}", 0, $fullpath);
return true;
}

//                                                                 
 //                                                                
 //                                                                 
 //                 
 $sql_publish = "SELECT page_id FROM publish WHERE filename='".sqlf_escaped($filename)."' AND folder_id IN ($keys) and page_id != ".sqlf_tl_num($id);
$rs_publish = query($sql_publish);//            
 while(list($key, $row) = each($rs_publish["arr"])) {
$conflict_id = $row["page_id"];
//                                            
 //                                                                                                                                                                           
 //                                                               #          
 $conflict_details = get_pageinfo($conflict_id);
if ($conflict_details === false) {
//                                                                                                             
 continue;
}
if($conflict_details["status"] == 1 && ($conflict_details["folder_id"] != $folder_id || $conflict_details["filename"] != $filename)) {
continue;
} else {
$folderinfo = get_folderinfo($conflict_details["folder_id"], true);
$fullpath   = $folderinfo["fullpath"]["name"] . '/' . $conflict_details["name"];
$ERROR["filename"] = i18n("A <em>published</em> page with this filename already exists:<br/> {0}", 0, $fullpath);
return true;
}
}

//                         
 if ( $name !== false )
{
$name = sqlslashes($name);
$sql = "SELECT count(page.id) AS c FROM page, folder WHERE page.name = '".sqlf_escaped($name)."' AND page.id != ".sqlf_tl_num($id)." AND page.folder_id = ".sqlf_tl_num($folder_id);
if ($cs_id) $sql .= " AND page.contentset_id != ".sqlf_tl_num($cs_id);
$rs = query($sql);//            
 if ($rs["arr"][0]["c"] > 0) {
$ERROR["name"] = $DIC[681];
return true;
}
}

return false;

}

function cmd_page_create($name,$desc,$priority,$filename,$template_id,$folder_id,$contentgroup_id=0,$contentset_id=0, $force_extension = false) {

global $TIME, $USER_ID, $ERROR, $W_CREATE, $T_PAGE, $CONTENT_ID, $FEATURE;

$sql = "SELECT node_id, pub_dir FROM folder WHERE id = ".sqlf_tl_num($folder_id);
$rs = query($sql);//            
 $node_id = $rs["arr"][0]["node_id"];
$pub_dir = $rs["arr"][0]["pub_dir"];

if ($filename && !$force_extension) {
$sql = "SELECT ml.ext FROM template, ml WHERE template.ml_id = ml.id AND template.id = ".sqlf_tl_num($template_id);
$rs = query($sql);//            
 if (!ereg("\.".$rs["arr"][0]["ext"]."$",$filename)) $filename .= ".".$rs["arr"][0]["ext"];
}

if (page_exists($name,$filename,$pub_dir,$node_id,$folder_id)) {
return false;
}

//                                   
 //                                                             
 //                       /                                                        
 node_include("contentgroup");
if ($CONTENT_ID) {
$content_id = $CONTENT_ID; //                                                               
 } else {
$content_id = get_contentId_for_contentset($contentset_id, $contentgroup_id);
if (!$content_id) {
$sql = "INSERT INTO content (node_id,creator,cdate,editor,edate)
VALUES (".sqlf_tl_num($node_id).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).")";
$rs = query($sql);//            
 $content_id = $rs["iid"];
}
}

if (!$content_id) halt(7,"cmd_page_create: insert of content failed: content_id($content_id)");

$a_name = sqlslashes($name);
$a_desc = sqlslashes($desc);
$a_filename = sqlslashes($filename);

if (!$contentgroup_id) $contentgroup_id = 0;
if (!$contentset_id && ($FEATURE["contentgroup3"]||$FEATURE["contentgroup"])) $contentset_id = cmd_page_createcs(); 
if ( !$FEATURE["contentgroup"] && !$FEATURE["contentgroup3"] ) {
$contentgroup_id = 0;
$contentset_id = 0;
}
if ( $contentgroup_id == 0 ) $contentset_id = 0;

$sql = "INSERT INTO page (name,description,filename,template_id,priority,content_id,folder_id,creator,cdate,editor,edate,contentgroup_id, contentset_id)
VALUES ('$a_name','$a_desc','$a_filename',".sqlf_tl_num($template_id).",".sqlf_tl_num($priority).",".sqlf_tl_num($content_id).",".sqlf_tl_num($folder_id).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($contentgroup_id).",".sqlf_tl_num($contentset_id).")";
$rs = query($sql);//            
 $page_id = $rs["iid"];


if ($name == "") {
$name = $page_id;
$sql = "UPDATE page SET name = \"".sqlslashes($name)."\" WHERE id = ".sqlf_tl_num($page_id);
query($sql);//            
 }

//                     
 if (!$filename) {
$sql = "SELECT ml.ext FROM template LEFT JOIN ml ON (template.ml_id = ml.id) WHERE template.id = ".sqlf_tl_num($template_id);
$rs = query($sql);//            
 $ext = $rs["arr"][0]["ext"];

if ( $FEATURE["get_filename_as_pagename"] ) {

//                                               
 $filename = convertToFilename( $name );
//                                      
 if ( strlen( $filename ) > 60 ) $filename = substr( $filename, 0, 59 );
if ( strlen( $filename ) == 0 ) $filename = $page_id;
$filename .= "." . $ext;
//                 
 } else {
$filename = $page_id . "." . $ext;
}
/** **/
if ( page_exists( $name, $filename, $pub_dir, $node_id, $folder_id, $page_id ) ) {
if ( $FEATURE["get_filename_as_pagename"] ) {
$filename = $filename.".".$page_id.".".$ext; 
}

$filename = unique_page_filename($filename, $folder_id, $page_id);
}

//                                         
 if ($FEATURE["contentgroup3_pagefilename"] && $contentgroup_id) {
//                    
 $folder_info = get_folderinfo($folder_id);
$cg = get_contentgroups($folder_info["node_id"]);

if ($FEATURE["contentgroup3_pagefilename_no_apachefilename"]) {
preg_match ("/(.*)\.([^\.]*)$/", $filename, $fparts);
//                                            
 //                                                     
 $fnamelength = 62 - 4 /*                */ - strlen($cg[$contentgroup_id]["code"]) - strlen($fparts[2]);
$filename = substr( $fparts[1], 0, $fnamelength ) . '.' . $cg[$contentgroup_id]["code"] . '.' . $fparts[2];
} else {
$filename .= ".".$cg[$contentgroup_id]["code"];
}
}

$a_filename = sqlslashes($filename);
$sql = "UPDATE page SET filename = '$a_filename' WHERE id = ".sqlf_tl_num($page_id);
query($sql);//            
 }

//                               
 tag_copy($template_id,"template",$content_id,"content");

global $T_FOLDER;

logcmd($W_CREATE,$T_PAGE,$page_id,$folder_id,"cmd_page_create");
triggerEvent( $T_PAGE, $page_id, EVENT_CREATE, new EventObject() );
//                                                                    
 //                                                                                                           
 trigger_event("onpagecreate",
array("page_id"=>$page_id,"folder_id"=>$folder_id));

return $page_id;
}

function cmd_page_del_all_versions( $ids ) {
global $T_PAGE;
while (list($id,$val) = each($ids)) {
node_class("cnpageobject");
$pageobject = new CNPageObject($id);
logcmd( W_DELALLVERSIONS, $T_PAGE, $id, 0, '' );
$pageobject->deleteAllVersions();
}
}

/**
 *                                                    
 *                                      
 *                                                                                     
 *                                                                                                                                                             
 *                                                                                           
 */
function cmd_page_del_wf($ids, $all_contentgroups = false, $forcelang = false) {
global $T_PAGE, $W_DEL, $USER_ID, $CONTENTGROUP_ID, $FEATURE, $DEBUG;

if (!is_array($ids)) halt(7,"cmd_page_del: not a valid array: ids($ids)");

$del_ids = array();
while (list($id,$val) = each($ids)) {
if ($all_contentgroups) {
if ($FEATURE['workflow_event_onpagedelete_all_lang']) {
//                                         
 if (trigger_event("onpagedelete_all_lang", array("page_id" => $id))) {
continue;
}
}
//                                                             
 $sql = "SELECT contentset_id FROM page WHERE id = ".sqlf_tl_num($id);
$rs = query($sql);//            
 //                                 
 if ($rs["arr"][0]["contentset_id"]) {
$sql = "SELECT id FROM page WHERE contentset_id = ".sqlf_tl_num($rs['arr'][0]["contentset_id"]);
$rs = query($sql);//            
 $pids = reduce_array($rs['arr'], 'id', 'id');
$del_ids = array_merge($del_ids, cmd_page_del_wf($pids, false, true));
continue;
}
} else {
$page = get_pageinfo($id);
//                                                          
 //                                        
 if (!$forcelang && (!isset($page["contentgroup_id"]) || $page["contentgroup_id"] != $CONTENTGROUP_ID)) {
continue;
}
}

//                        
 if (trigger_event("onpagedelete",array("page_id"=>$id))) {
continue;
} else {
$del_ids[] = $id;
}
}
return $del_ids;
}

/**
 *                                          
 *                                      
 *                                                                                     
 *                                                                                                                                                             
 *                                                    
 */
function cmd_page_del($ids, $all_contentgroups = false, $forcelang = false) {

global $T_PAGE, $W_DEL, $USER_ID, $CONTENTGROUP_ID, $FEATURE, $DEBUG, $ERROR, $JAVAPARSER_RETURN;

if (!is_array($ids)) halt(7,"cmd_page_del: not a valid array: ids($ids)");

//                            
 $wf_ids = cmd_page_del_wf($ids, $all_contentgroups, $forcelang);
$del_ids = array();

while (list($key, $id) = each($wf_ids)) {
if ($all_contentgroups) {
$sql = "SELECT contentset_id FROM page WHERE id = ".sqlf_tl_num($id);
$rs = query($sql);//            

//                                 
 if ($rs["arr"][0]["contentset_id"]) {
$sql = "SELECT id FROM page WHERE contentset_id = ".sqlf_tl_num($rs['arr'][0][0]);
$rs = query($sql);//            
 $pids = reduce_array($rs['arr'], 'id', 'id');
$del_ids = array_merge($del_ids, $pids);
} else {
$del_ids[$id] = $id;
}
} else {
$page = get_pageinfo($id);
//                                                          
 //                                        
 if (!$forcelang && (!isset($page["contentgroup_id"]) || $page["contentgroup_id"] != $CONTENTGROUP_ID)) {
continue;
} else {
$del_ids[$id] = $id;
}
}
}

$error = false;
if (!empty($del_ids)) {
//                
 $javaParser =& CodeParser::getJavaParser();
$ERROR = $javaParser->deleteObject(T_PAGE, $del_ids);
if (!empty($ERROR)) {
$error = true;
if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
halt(7, $ERROR);
}
}
}

return $error;
}

function cmd_page_switch_template($id, $template_id, $synctags) {
global $FEATURE;
$sql = "SELECT id, name, description, priority, filename, template_id, status, contentset_id, contentgroup_id, content_id FROM page WHERE id = ".sqlf_tl_num($id);
$rs = query($sql);//            
 $pages = array();
if ( $FEATURE["contentgroup3"] && $rs["arr"][0]["contentset_id"] > 0) 
{
$sql = "SELECT id, name, content_id, description, priority, filename, template_id, status, contentgroup_id FROM page WHERE contentset_id = ".sqlf_tl_num($rs["arr"][0]["contentset_id"]);
$rs = query($sql);//            
 $pages = $rs["arr"];
}
else 
{
$pages[] = $rs["arr"][0];
}

$ret = array();
foreach ( $pages as $r )
{
if ($synctags) {
//                                  
 tag_copy($template_id,"template",$r['content_id'],"content");
//                                                                        
 }

$ret[$r["id"]] = cmd_page_update($r["id"], $r["name"], $r["description"], $r["priority"], $r["filename"], $template_id, $r["status"], $r["contentgroup_id"]);
}
return $ret;
}


function cmd_page_update($id,$name,$desc,$priority,$filename,$template_id,$status,$contentgroup) {

global $TIME, $USER_ID, $T_PAGE,$W_EDIT, $T_FOLDER, $FEATURE;

//                                     
 $modified = array();

$sql = "SELECT folder.id, folder.node_id, folder.pub_dir, page.template_id, page.name, page.description, page.priority, 
  page.priority, page.filename, page.status, page.contentgroup_id, page.content_id FROM folder, page
WHERE page.folder_id = folder.id AND page.id = ".sqlf_tl_num($id);
$rs = query($sql);//            
 $pub_dir = $rs["arr"][0]["pub_dir"];
$node_id = $rs["arr"][0]["node_id"];
$folder_id = $rs["arr"][0]["id"];
$old_page = $rs["arr"][0];

//                                    
 if ($name != $old_page["name"]) {
$modified[] = "name";
}
if ($desc != $old_page["description"]) {
$modified[] = "description";
}
if ($priority != $old_page["priority"]) {
$modified[] = "priority";
}
if ($template_id != $old_page["template_id"]) {
$modified[] = "template";
//                                 
 }
if ($contentgroup != $old_page["contentgroup_id"] && ($FEATURE["contentgroup"] || $FEATURE["contentgroup3"])) {
//                              
 }

//                              
 $old_template = get_templateinfo($rs["arr"][0]["template_id"]);
$new_template = get_templateinfo($template_id);
$old_ml = get_mlinfo($old_template["ml_id"]);
$new_ml = get_mlinfo($new_template["ml_id"]);
$old_ext = $old_ml["ext"];
$new_ext = $new_ml["ext"];
if ($old_ext != $new_ext) $filename = ereg_replace("\.$old_ext$",".$new_ext",$filename);


//                     
 if (!$filename) {
//                                                                                                             
 //                                                                              
 $sql = "SELECT ml.ext FROM template, ml WHERE template.ml_id = ml.id AND template.id = ".sqlf_tl_num($template_id);
$rs = query($sql);//            
 $ext = $rs["arr"][0]["ext"];

if ( $FEATURE["get_filename_as_pagename"] )
{
//                                               
 $filename = convertToFilename( $name );
if ( strlen( $filename ) > 60 ) $filename = substr( $filename, 0, 59 );
$filename .= "." . $ext;

} else
{
$filename = $id . "." . $ext;
}

}

//                                    
 if (!strpos($filename,".",1)) $filename = $filename.".".$new_ext;

if (page_exists($name,$filename,$pub_dir,$node_id,$folder_id,$id)) return false;

if ($status == 2) {
if (perm($USER_ID,$T_FOLDER,$folder_id,19)) $status = 1;
else $status = 4;
}
if ($status == 5) $status = 0;

//                      
 if ($old_page["name"] == $name && $old_page["description"] == $desc && $old_page["priority"] == $priority && 
$old_page["filename"] == $filename && $old_page["template_id"] == $template_id && 
($old_page["contentgroup_id"] == $contentgroup || (!$FEATURE["contentgroup"] && !$FEATURE["contentgroup3"]))) return false;

//                            
 if ($filename != $old_page["filename"]) {
$modified[] = "filename";
}

page_status($id,$status,$USER_ID);

$name = sqlslashes($name);
$description = sqlslashes($desc);
$filename = sqlslashes($filename);

if ( ($FEATURE["contentgroup"] || $FEATURE["contentgroup3"]) && $contentgroup )
$dbcontentgroup =", contentgroup_id = ".(int)$contentgroup;

$sql = "UPDATE page SET name = '$name', description = '$description', priority = ".sqlf_tl_num($priority).", filename = '$filename', 
editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME).", template_id = ".sqlf_tl_num($template_id).", status = ".sqlf_tl_num($status)." $dbcontentgroup
WHERE id = ".sqlf_tl_num($id);
query($sql);//            

logcmd($W_EDIT,$T_PAGE,$id,$folder_id,"cmd_page_update");
triggerEvent( $T_PAGE, $id, EVENT_UPDATE, 
new EventObject( array( "name"=>$name, "description"=>$description, "priority"=>$priority,
"filename"=>$filename, "editor"=>$USER_ID, "template_id"=>$template_id, "status"=>$status ) ) );

//                                           
 if ($FEATURE["javaparser"]) {
$javaParser =& CodeParser::getJavaParser();
$javaParser->clearCache($T_PAGE, $id);
}

return $id;

}

function cmd_page_time_update($page_id,$from,$to,$weekdays,$pub = false) {

global $TIME, $USER_ID, $T_PAGE, $FEATURE;

if (!$page_id) halt(7,"cmd_page_time_update: No Page_id. page_id($page_id)");

if (!$from) $from = 0;
if (!$to) $to = 0;
if (in_array(1,$weekdays)) $w1 = 1; else $w1 = 0;
if (in_array(2,$weekdays)) $w2 = 1; else $w2 = 0;
if (in_array(3,$weekdays)) $w3 = 1; else $w3 = 0;
if (in_array(4,$weekdays)) $w4 = 1; else $w4 = 0;
if (in_array(5,$weekdays)) $w5 = 1; else $w5 = 0;
if (in_array(6,$weekdays)) $w6 = 1; else $w6 = 0;
if (in_array(7,$weekdays)) $w7 = 1; else $w7 = 0;

$page = get_pageinfo($page_id);

$sql = "UPDATE page SET time_start = ".sqlf_tl_num($from).", time_end = ".sqlf_tl_num($to).", time_mon = $w1, time_tue = $w2, time_wed = $w3, time_thu = $w4, time_fri = $w5, time_sat = $w6, time_sun = $w7 ".($pub !== false ? ", time_pub = ".sqlf_tl_num($pub) : "")." WHERE id = ".sqlf_tl_num($page_id);
query($sql);//            

if ($pub !== false && $page["time_pub"] != $pub) {
page_status($page_id, 0);
}

cmd_page_settimestate($page_id);

//                                           
 if ($FEATURE["javaparser"]) {
$javaParser =& CodeParser::getJavaParser();
$javaParser->clearCache($T_PAGE, $page_id);
}

return true;
}

//                                                                                                                
function cmd_page_settimestate($page_id) {

global $TIME;

if (!$page_id) halt(7,"cmd_page_settimestate: No page_id! page_id($page_id)");

$sql = "SELECT time_pub, editor, publisher, status, time_start, time_end, time_mon, time_tue, time_wed, time_thu, time_fri, time_sat, time_sun FROM page WHERE id = ".sqlf_tl_num($page_id);
$rs = query($sql);//            
 if (!$rs["arr"]) return false;
$r = $rs["arr"][0];

$day = strtolower(date("D",$TIME));

$active = $r["time_$day"];

//                                                              
 if ($r["time_pub"] > 0 && $r["time_pub"] < $TIME && ($r["status"] == 0 || $r["status"] == 3)) {
cmd_page_pub($page_id);
$sql = "select status from page where id = ".sqlf_tl_num($page_id);
$rs = query($sql);//            
 $r["status"] = $rs["arr"][0]["status"];
$sql = "UPDATE page SET time_pub = 0 WHERE id = ".sqlf_tl_num($page_id);
query($sql);//            
 }

if ($r["time_start"] <= $TIME && ($r["time_end"] > $TIME || $r["time_end"] <= 0) && $active) $state = 1; else $state = 5;

//                                   
//                                                                                                                         
 if ($r["time_start"] != 0 && (($state == 5 && ($r["status"] == 2 || $r["status"] == 1)) || ($state == 1 && $r["status"] == 5))) { 
page_status($page_id,$state,$r["publisher"]);

//                                                                 
//    //            //                  
 
return $state;
} return false;
}

//             
function cmd_page_move($source, $target, $uid=0, $all_contentgroups = true) {
global $USER_ID, $TIME, $DIC, $W_MOVE, $T_FOLDER, $ERROR, $T_PAGE, $FEATURE;

if (!$source) halt(0,"cmd_folder_move: No source to move");
if (!$target) halt(0,"cmd_folder_move: No target to move");

if (!$uid) $uid = $USER_ID;

$sql = "SELECT node_id,pub_dir FROM folder WHERE id = ".sqlf_tl_num($target);
$rs = query($sql);//            
 $node_id = $rs["arr"][0]["node_id"];
$pub_dir = $rs["arr"][0]["pub_dir"];

if (!is_array($source)) {
$source = array($source => true);
}

$source = array_unique(array_keys($source));

//                                              
 foreach ($source as $page_id) {
if ( ! perm_can_delete_page($page_id) ) {
$page_info = get_pageinfo($page_id);
$folder_info = get_folderinfo($page_info['folder_id'], true);
$page_path = implode('/', $folder_info['fullpath']) . '/' . $page_info['name'];
$ERROR = i18n('error.perm.pagemove.sourceremove', 0, $page_path);
return true;
}
}

//                        
 if (!perm($uid,$T_FOLDER,$target,12)) {
foreach ($source as $key) {
$sql = "SELECT contentgroup_id,contentset_id FROM page where id = '".sqlf_escaped($key)."'";
$rs = query( $sql );//            
 foreach( $rs['arr'] as $row ) {
if ($all_contentgroups && $row['contentset_id']) {
//                                                           
 $sql = "SELECT contentgroup_id FROM page where contentset_id = '".sqlf_escaped($row['contentset_id'])."'";
$rs1 = query( $sql );//            
 foreach( $rs1['arr'] as $row1 ) {
if (!perm($uid,$T_FOLDER,$target,12,$row1['contentgroup_id'], $T_PAGE, 11)) {
$ERROR = $DIC[851];
return true;
}
}
} else {
if (!perm($uid,$T_FOLDER,$target,12,$row['contentgroup_id'], $T_PAGE, 11)) {
$ERROR = $DIC[851];
return true;
}
}
}
}
}

if ($all_contentgroups) {
foreach ($source as $key) {
$sql = "SELECT contentset_id FROM page WHERE id = ".sqlf_tl_num($key)." AND contentset_id != 0";
$rs = query($sql);//            
 if ($rs["num"] > 0) {
$sql = "SELECT id FROM page WHERE contentset_id = ".sqlf_tl_num($rs['arr'][0][0]);
$rs = query($sql);//            
 $pids = reduce_array($rs['arr'], 'id', 'id');
} else {
$pids = Array();
$pids[$key] = true;
}
if ($err = cmd_page_move($pids, $target, $uid, false)) {
//                                                   
 //                                                      
 //                   
 $error = $err;
}
}
return $error;
}

//              
 $sql = "SELECT id, folder_id, name, filename, contentgroup_id"
. " FROM page"
. " WHERE id IN (" . implode(",", sqlf_tl_num_array($source)) . ")";
$rs = query($sql);//            
 $move = $rs["arr"];

//                                                                  
 //                                                                 
 //          
 $sql = "SELECT COUNT(id) conflict"
. " FROM page"
. " WHERE id IN (" . implode(",", sqlf_tl_num_array($source)) . ")"
. " GROUP BY name"
. " HAVING COUNT(DISTINCT contentset_id) > 1";
$rs = query($sql);//            
 if ($rs['arr'][0]['conflict']) {
$ERROR = i18n('There exists a duplicate page name among the pages to be moved.');
return true;
}

//                                                                   
 if (   $FEATURE["page_move_error_on_duplicate_filename"]
&& ! is_unique_db_column_ci($move, "filename"))
{
$ERROR = i18n("There exists a duplicate filename among the pages to be moved.");
return true;
}

//                                                             
 //                                                            
 //                                                     
 foreach ($move as $key => $page) {
//                                                                           
 if ($page["folder_id"] == $target) {
unset($move[$key]);
continue;
}

//                                                              
 //                                                             
 //                  
 if (page_exists(false, $page["filename"], $pub_dir, $node_id, $target, $page["id"])) {
if ($FEATURE["page_move_error_on_duplicate_filename"]) {
$ERROR = $ERROR["filename"] ? $ERROR["filename"] : $ERROR["name"];
return true;
}
//                                                
 //                                                             
 $page["filename"] = unique_page_filename($page["filename"], $page["folder_id"], $page["id"]);
//                                                 
 $move[$key] = $page;
}

//                                                          
 //                                                          
 if (page_exists($page["name"], $page["filename"], $pub_dir, $node_id, $target, $page["id"])) {
//                                                  
 $ERROR = $ERROR["filename"] ? $ERROR["filename"] : $ERROR["name"];
return true;
}
}

//                                                                
 //                                                               
 //                                        
 $double_check_filenames = ! is_unique_db_column_ci($move, "filename");

//                     
 $ignore_user_abort = ignore_user_abort(true);

foreach ($move as $page) {
//                        
 if (trigger_event("onpagemove", array("page_id" => $page["id"], "to_folder_id" => $target))) {
continue;
}

if ($double_check_filenames) {
//                                                          
 //                                                                
 if (page_exists($page["name"], $page["filename"], $pub_dir, $node_id, $target, $page["id"])) {
$page["filename"] = unique_page_filename($page["filename"], $page["folder_id"], $page["id"]);
}
}

$sql = "UPDATE page SET folder_id = ".sqlf_tl_num($target).", edate = ".sqlf_tl_num($TIME).", editor = ".sqlf_tl_num($uid)
. ", filename = '" . sqlslashes($page["filename"]) . "'"
. " WHERE id = " . sqlf_tl_num($page["id"]);
query($sql);//            
 }

node_class("cnpageobject");

foreach ($source as $page_id) {
//                                      
 $o_page = new CNPageObject($page_id);
$o_page->createVersion($TIME, $USER_ID);
logcmd($W_MOVE, $T_PAGE, $page_id , $target, "cmd_file_move");
triggerEvent( $T_PAGE, $page_id, EVENT_MOVE, new EventObject( array("toId"=>$target) ) );
//                                         
 triggerEvent(T_FOLDER, $target, EVENT_UPDATE, new EventObject(null, "pages"));
}

//                                          
 $source_folders = array_unique(array_column($move, "folder_id"));
foreach ($source_folders as $folder_id) {
triggerEvent(T_FOLDER, $folder_id, EVENT_UPDATE, new EventObject(null, "pages"));
}

ignore_user_abort($ignore_user_abort);
return false;
}

/**
 *                                                                
 *                             
 */
function is_unique_db_column_ci($rows, $field) {
$unique_column = array_unique(array_map(cb_cutright('mb_strtolower', 'UTF-8'),
array_column($rows, $field)));
return count($rows) == count($unique_column);
}

//                         
function cmd_page_setcdate($page_id,$cdate) {

if (!$page_id) halt(7,"cmd_page_setcdate: no page_id page_id($page_id)");
if ($cdate == "") halt(7,"cmd_page_setcdate: no cdate cdate($cdate)");

$sql = "UPDATE page SET cdate=".sqlf_tl_num($cdate)." WHERE id=".sqlf_tl_num($page_id);
query($sql);//            
}

function cmd_page_createcs() {
$sql = "INSERT INTO contentset (nada) VALUES (0)";
$rs = query($sql);//            
 return $rs["iid"];
}

//                                                                                                      
function cmd_page_checkandfixcs($page_id) {
$sql = "select contentset_id from page where id = ".sqlf_tl_num($page_id);
$rs = query($sql);//            
 if ($rs["arr"][0]["contentset_id"] == 0) {
$cs = cmd_page_createcs();
$sql = "update page set contentset_id = ".sqlf_tl_num($cs)." where id = ".sqlf_tl_num($page_id);
query($sql);//            
 }
}

function cmd_page_setcg($current_page_id,$page_id,$cg) {
global $JS;

$page = get_pageinfo($current_page_id);
$cs = $page["contentset_id"];

if ($cg && $page_id) {
$page2 = get_pageinfo($page_id);
$cs1 = $page["contentset_id"];
$cs2 = $page2["contentset_id"];
$cg1 = $page["contentgroup_id"];
$cg2 = $page2["contentgroup_id"];

/*
                     
                                                                                         
                
   
*/

$sql = "UPDATE page SET contentgroup_id = ".sqlf_tl_num($cg)." WHERE id = ".sqlf_tl_num($page_id);
query($sql);//            
 $cg2 = $cg;

//                                        
 if (!$cs1 && $cs2) {
$sql = "UPDATE page SET contentset_id = 0 WHERE contentgroup_id = ".sqlf_tl_num($cg1)." AND contentset_id = ".sqlf_tl_num($cs2);
query($sql);//            
 $sql = "UPDATE page SET contentset_id = ".sqlf_tl_num($cs2)." WHERE id = ".sqlf_tl_num($current_page_id);
query($sql);//            
 //                                        
 } else if ($cs1) {
$sql = "UPDATE page SET contentset_id = 0 WHERE contentgroup_id = ".sqlf_tl_num($cg2)." AND contentset_id = ".sqlf_tl_num($cs1);
query($sql);//            
 $sql = "UPDATE page SET contentset_id = ".sqlf_tl_num($cs1).", contentgroup_id = ".sqlf_tl_num($cg)." WHERE id = ".sqlf_tl_num($page_id);
query($sql);//            
 //                                                  
 } else {
$cs = cmd_page_createcs();
$sql = "UPDATE page SET contentset_id = ".sqlf_tl_num($cs)." WHERE id IN (".sqlf_tl_num($current_page_id).",".sqlf_tl_num($page_id).")";
query($sql);//            
 }
}

return true;

}

function cmd_page_restore_all( $folder_id, $vdate, $recursive = false )
{
global $ICO_PAGE;
$sql = "SELECT id, name FROM page WHERE folder_id = ".sqlf_tl_num($folder_id);
$rs = query( $sql );//            
 foreach ( $rs["arr"] as $page )
{
$o_page = new CNPageObject($page["id"]);
if ( !$o_page->restore($vdate) )
{
$alert = new AlertStreamInfo();
$alert->addMessage( 0, $ICO_PAGE, i18n( "Could not restore page {0}", 0, $page["name"] ),
i18n( "Maybe the page is locked by another user" ) );
}

}
}


function cmd_page_save($id) {

unlock($id,"page");

}

function cmd_page_pub($id, $notify=false) {

global $USER_ID, $T_FOLDER, $T_PAGE;

//                                       
 $page = get_pageinfo($id);
$folder_id = $page["folder_id"];

//                          
 if (perm($USER_ID,$T_FOLDER,$folder_id,19,$page['contentgroup_id'], $T_PAGE, 14)) {
$status = 1;
query("UPDATE page SET time_pub = 0 WHERE id = ".sqlf_tl_num($id));//            
 } else {
//                                                      
 if(!perm($USER_ID, $T_FOLDER, $folder_id, 11, $page['contentgroup_id'], $T_PAGE, 10)) {
return;
}
$status = 4;
query("UPDATE page SET time_pub = 0 WHERE id = ".sqlf_tl_num($id));//            
 publishpage_msg($id,$folder_id);
}
page_status($id,$status,$USER_ID,$notify);
cmd_page_settimestate($id);
unlock($id,"page");
}

function cmd_page_setdirtbehaviour($id, $dirtbehaviour) {
query("UPDATE page SET dirtbehaviour = ".sqlf_value($dirtbehaviour)." WHERE id = ".sqlf_tl_num($id));//            
}

/*
 *                                                                                                                                 
 *                        
 *                                            
 */
function cmd_page_timepub($page_id, $time_pub = 0) {
global $USER_ID, $TIME, $T_FOLDER, $T_PAGE;
if (!$page_id) halt(7,"cmd_page_timepub: No page_id! page_id($page_id)");

if ($time_pub == 0) {
//                                           
 query("UPDATE page SET time_pub = 0 WHERE id = ".sqlf_tl_num($page_id));//            
 page_status($page_id, 0);
} else if ($time_pub < $TIME) {
//                                                                  
 query("UPDATE page SET time_pub = 0 WHERE id = ".sqlf_tl_num($page_id));//            
 cmd_page_pub($page_id);
} else {
$page = get_pageinfo($page_id);
$folder_id = $page["folder_id"];

//                                     
 query("UPDATE page SET time_pub = ".sqlf_tl_num($time_pub)." WHERE id = ".sqlf_tl_num($page_id));//            

if (perm($USER_ID, $T_FOLDER, $folder_id, 19, $page['contentgroup_id'], $T_PAGE, 14)) {
$status = 6;
} else {
//                                                      
 if (!perm($USER_ID, $T_FOLDER, $folder_id, 11, $page['contentgroup_id'], $T_PAGE, 10)) {
return;
}
$status = 4;
publishpage_msg($page_id, $folder_id);
}
page_status($page_id, $status, $USER_ID, false);
unlock($page_id,"page");
}
}

?>
