<?
/**
 *                                        
 *
 *                                                                          
 *                                                                  
 *
 *                                  /            
 *
 *                                      
 *                                      
 *                                
 *             
 *             
 *               
 *              
 *                 
 *             
 *
 *                                   
 *                      
 *                                                                      
 *
 *                                                                                         
 *                                                      
 *                     
 *                                    
 */

///                                                                                       
global $XNL_PATH;
include_once($XNL_PATH.'/gentics/gentics_lib.inc.php');

function xnl_func_gentics_ldap_query($code, &$info)
{
//                    
 $server = $info->getParam('ldap_server');
$base_dn = $info->getParam('ldap_base_dn');
$port = $info->getParam('ldap_port');
$user = $info->getParam('ldap_user');
$pass = $info->getParam('ldap_pass');
$search = $info->getParam('ldap_search');
$limit = $info->getParam('ldap_limit');
$template = $info->getParam('ldap_template');
$sort = $info->getParam('ldap_sort');
$decodeutf8 = strtolower($info->getParam('ldap_decode_utf8'));
if ($decodeutf8 == "false" || $decodeutf8 == "0" || $decodeutf8 == "off") $decodeutf8 = false;

if (!$port) $port = 389;
if (!$server) $server = 'localhost';
//      
 //                                                                                   
 $con = @ldap_connect($server, $port);
if ($con && strpos($search, '**') === false) 
{
if (!$user || ldap_bind($con, $user, $pass))
{
$res = ldap_search($con, $base_dn, $search);
if ($sort) ldap_sort($con,$res,$sort);
if ($res)
{
$entries = ldap_get_entries($con, $res);
$ret = '';
//                   
 if ($entries['count'] < $limit || !$limit) $limit = $entries['count'];
for ($i=0; $i<$limit; $i++)
{
$row = $template;
for ($j=0; $j<$entries[$i]['count']; $j++)
{
$attr = $entries[$i][$j];
if (is_array($entries[$i][$attr]))
{
$value = $entries[$i][$attr][0];
} 
else 
{
$value = $entries[$i][$attr];
}
if ($decode_utf8) $value = utf8_decode($value);
$row = str_replace("<ldap_$attr>", $value, $row);
}
$ret .= $row;
}
return $ret;
} 
else 
{
$info->error( "bind", "Could not bind to basedn" );
return "";
}
} 
else 
{
$info->error( "login", "Could not login into server with spezified user/pass." );
return "";
}
} 
else 
{
$info->error( "connect", "Could not connect to ldap server or search string is **." );
return "";
}
}
?>
